/*1.Dziedziczenie wielobazowe bez powtorzen - klasa wirtulana
  2.Dziedziczenie z przedefiniowaniem i bez przedefiniowania metod

 Cel zadania (punkty 1-4 jak w lab6_2.cpp w LAB10_1):
 1.Zrealizowac klase n_ramka do rysowania zgodnie z ustalonymi
   kolorami tla i pisma napisu we wskazanym punkcie (x,y)
   w ramce o podanych rozmiarach i polozeniu lewego gornego naroznika.
   Klasa n_ramka dziedziczy od klasy ramka oraz klasy napis.
 2.Klasy napis i ramka dziedzicza pola i metody od klasy punkt, ktora ma:
   pola x,y, konstruktory zwykly i kopiujacy, destruktor, przeciazone
   operatory-- i ++ do powiekszania i zmniejszania o 1 wartosci pol,
   metody dostepu do pol, metode odleglosc do wyznaczania odleglosci
   miedzy dwoma punktami-*this oraz przekazanym przez wartosc do metody.
 3.Klasa napis posiada: pola wiersz  w postaci tablicy dynamicznej znakow
   i dlugosc do przechowywania dlugosc wiersza oraz: konstruktory
   zwykly i kopiujacy, destruktor, metody dostepu do pol wiersz
   oraz dlugosc, metode rysuj do wyswietlania napisu we wskazanym
   punkcie ekranu, operatory ++ oraz -- (zwiekszajace lub zmniejszajace
   o 1 bajt obszar w pamieci przeznaczony do przechowywania wiersza oraz
   zmieniajace wspolrzedne wiersza x,y operatorami-- i ++ klasy punkt) oraz
   przeciazony operator=.
 4.Klasa ramka posiada pola dlugosc i wysokosc rysowanej ramki,
   konstruktory zwykly i kopiujacy, destruktor, metody dostepu do pol
   dlugosc oraz wysokosc, operatory ++ oraz -- (zwiekszajace lub
   zmniejszajace o 1 wartosc pol wysokosc i dlugosc oraz wartosci
   wspolrzednych x,y za pomoca dziedziczonych operatorow++ i --
   od klasy punkt), metode rysuj do rysowania ramki o rozmiarach
   dlugosc i wysokosc w punkcie (x,y.)
 5.Klasa n_ramka posiada:pole atrybuty, konstruktory zwykly i kopiujacy,
   destruktor, metody dostepu do pola atrybuty, metode rysuj rysujaca napis
   w ramce za pomoca dziedziczonych metod rysuj od klas ramka i napis
   oraz operatory ++ oraz -- (zwiekszajace lub zmniejszajace  o 1 wartosc
   pola atrybuty oraz za pomoca dziedziczonych operatorow-- i ++ od klas
   ramka i napis rozmiary i polozenie ramki, obszar pamieci przeznaczony
   na napis). Pola i metody klasy punkt sa dziedziczone przez klase
   n_ramka jednokrotnie, stad:
   * bezposrednie odwolania do skladowych klasy punkt sa jednoznaczne!
   * wspolrzedne polozenia napisu i ramki sa wspolne.

Zadanie do wykonania:
 Zastanow sie, jak mozna wykorzystac gotowe pliki z LAB10_1, aby
 latwo wykonac zadanie LAB1_2!!! ?

 1.Wykonaj konstruktory: zwykly i kopiujacy za pomoca listy
   w klasach punkt (punkt6_3.cpp), ramka(ramka6_3.cpp),
   napis(napis6_3.cpp) i n_ramka(nramka6_3.cpp). W klasie napis
   zastosuj wszedzie, gdzie to mozliwe metode kopiuj przy definicji
   konstruktorow i przeciazonych operatorow.
 2.Wykonaj operatory operator++ oraz operator-- przedrostkowe
   w klasie punkt, ramka, napis oraz n_ramka.
   Metody te powinny zwiekszac lub zmniejszac pola x i y w klasie punkt;
   rozmiar tablicy znakow oraz polozenie napisu na ekranie
   w klasie napis; wspolrzedne x,y polozenia ramki oraz wymiary
   dlugosc i wysokosc w klasie ramka; oraz dodatkowo atrybuty
   w klasie n_ramka.
   W definicjach operatorow w klasach n_ramka, ramka i napis wykorzystaj
   dziedziczenie operatorow -- oraz ++ odpowiednio od klas 
   punkt i ramka i napis.
 3.Wykonaj pozostale metody w klasach punkt, ramka, napis oraz n_ramka
   tak, aby wykonany program dzialal podobnie jak program lab6_3.exe.
 4.Zastosowac dyrektywy uniemozliwiajace ponowna kompilacje
   plikow naglowkowych: punkt6_3.h z deklaracja klasy punkt
   ramka6_3.h z deklaracja klasy ramka, napis6_3.h z deklaracja
   klasy napis oraz nram6_3.h z deklaracja klasy n_ramka.
   Uzupelnij pozostale makrodefinicje w plikach naglowkowych.
 5.Wykonaj projekt zawierajacy:plik punkt6_3.cpp zawierajacy definicje
   metod klasy punkt, plik ramka6_3.cpp zawierajacy definicje metod
   klasy ramka, plik napis6_3.cpp zawierajacy definicje metod
   klasy napis, plik nram6_3.cpp zawierajacy definicje metod klasy
   n_ramka oraz program wykorzystujacy te klasy lab6_3 .cpp.

Pytania kontrolne:
 1.Podaj sposob wywolania operatora-- z klasy ramka i klasy napis
   przez obiekt klasy n_ramka(r_n1 lub r_n2). Czy mozna to zrobic
   dla klasy punkt?
 2.Wymien wszystkie metody, jakie posiada klasa ramka i podaj sposob
   ich wywolania.
 3.Wymien wszystkie metody, jakie posiada klasa napis i podaj sposob
   ich wywolania.
 4.Wymien wszystkie metody, jakie posiada klasa n_ramka i podaj sposob
   ich wywolania.
 5.Podaj zasady tworzenia i wywolywania konstruktorow na przykladzie
   klasy n_ramka.
 6.Podaj zasady tworzenia i wywolania destruktorow na przykladzie
   klasy n_ramka.
 7.Dokonaj proby wywolania metody: void wyswietl(n_ramka& p, char *napis),
   gdy zastosowano rzutowanie obiektow i podaj, co sie zmienilo?*/

#include "nram6_3.h"
#include <iostream.h>
#include <conio.h>

void wyswietl(n_ramka&, char * kom);
void wyswietl(ramka&, char * kom);
void wyswietl(napis&, char * kom);
void wyswietl(punkt&, char * kom);
void wyswietl(float, char * kom);

main()
{ clrscr();
 { n_ramka r_n1(36,5,38,7,19,8,"napis w ramce_1",0x3A),
   r_n2(54,1,57,3,19,5,"napis w ramce_2",0x1B);
   ramka   r1(35,13,20,8),     r2(57,12,20,5);
   napis   n1(35,21,"napis1"), n2(60,20,"napis2");
   punkt p1 (2,3),	      p2(2,8);
   wyswietl(r_n1,"  r_n1\n"); wyswietl(r_n2,"  r_n2\n");
   wyswietl(r1,"  r1\n"); 	 wyswietl(r2,"  r2\n");
   wyswietl(n1,"  n1\n"); 	 wyswietl(n2,"  n2\n");
   wyswietl(p1,"  p1\n"); 	 wyswietl(p2,"  p2\n");
   //przedefiniowane przeciazone metody-operatory++ i --
   //zdefiniowane za pomoca operatorow ++ i -- dziedziczonych
   //od klas punkt, ramka i napis
   wyswietl(--r_n1,"  --r_n1\n");  wyswietl(++r_n2,"  ++r_n2\n");
   wyswietl(--r1,"  --r1\n");      wyswietl(++r2,"  ++r2\n");
   wyswietl(--n1,"  --n1\n");      wyswietl(++n2,"  ++n2\n");
   wyswietl(--p1,"  --p1\n");      wyswietl(++p2,"  ++p2\n");
   clrscr();
 //brak bladu przy wywolywaniu metod klasy wirtualnej na rzecz obiektow 
 // n_ramka-sytuacja jednoznaczna
   wyswietl(r_n1.odleglosc(r_n2),"Odleglosc miedzy ramkami z napisem: ");
 //metoda dziedziczone od klasy punkt
   wyswietl(r1.odleglosc(r2),"Odleglosc miedzy ramkami: ");
   wyswietl(n1.odleglosc(n2),"Odleglosc miedzy napisami: ");
   wyswietl(p1.odleglosc(p2),"Odleglosc miedzy punktami: ");
 //metoda przedefiniowana rysuj obiektow r_ramka
   getch(); clrscr();
   r_n1.rysuj();
   r_n2.rysuj();
   --r_n1;          //zmiana polozenia ramki i jej rozmiarow oraz koloru
                    //tuszu oraz pamieci przeznaczonej na napis
   r_n2=r_n1;       //standardowy operator= wywoluje przeciazony operator=
                    //klasy napis na rzecz klasy n_ramka i stad oba obiekty maja
                    //wszystkie pola rowne,lecz w roznych obszarach pamieci
                    //oba obiekty zostana narysowane w tym samym punkcie
   r_n1.rysuj();
   r_n2.rysuj();
                     //metoda wlasna rysuj obiektow ramka
   r1.rysuj();
   r2.rysuj();
                     //metoda wlasna rysuj obiektow napis
   n1.rysuj();
   n2.rysuj();
   getch();
   n2.rzedna()+=3;  //zmiana wspolrzednej y napisu metoda klasy punkt
   n1=n2;           //wywolanie przeciazonego operatora = z klasy napis
   wyswietl(n1.odleglosc(n2),"Odleglosc miedzy napisami: ");
   n1.rysuj();      //napisy zostana wyswietlone w tym samym miejscu
   n2.rysuj();
   getch();
   clrscr();
 }
   return 0;
}

void wyswietl(n_ramka& p, char *kom)
{
 cout << " Atrybuty: " << p.p_atrybuty();
 wyswietl(*((ramka*)&p),"\n");
 wyswietl(*((napis*)&p),kom);
 getch();
}
void wyswietl(ramka& p, char *kom)
 {
   cout << " Dlugosc, Wysokosc: " << p.p_dlugosc() << ", "
	 <<p.p_wysokosc() <<" ";
   wyswietl(*((punkt*)&p),kom); //uwaga w funkcji wyswietl dla r_ramki
 }

void wyswietl(napis& p, char *kom)
 {
   cout << "Wiersz: " << p.p_wiersz();
   wyswietl(*((punkt*)&p),kom); //uwaga w funkcji wyswietl dla r_ramki
 }

void wyswietl(punkt& p, char *kom)
{
 cout << " Wspolrzedne: " << p.odcieta() << " "<< p.rzedna() <<kom;
 getch();
}

void wyswietl(float w,char *napis)
{
 cout <<napis<< w << '\n';
 getch();
}
