/* Glowne zagadnienia:
   * dziedziczenie - polimorfizm,
   * klasa abstrakcyjna,
   * lista jako tablica dynamiczna wskaznikow klasy abstrakcyjnej abstr

Liste mozna wykorzystac do przechowania wskaznikow wszystkich obiektow
pochodnych klasy abstr. Sa nimi obiekty z LAB12_1.
W tablicy listy nalezy umieszczac dane podobnie jak na stosie ( zawsze
za ostatnio wstawionym elemencie), natomiast nalezy usuwac na poczatku
tablicy. Zastosowac idee tablicy cyklicznej tzn.gdzie wstawia sie
adresy obiektow jako element tab[(kon%=rozmiar)++] oraz
usuwa sie jako element tab[(pocz%=rozmiar)++].

Opis klasy stos zamieszczono w pliku Wyklad12.doc.

Zadania do wykonania:
1. Zastosowac pliki naglowkowe i pliki modulowe z LAB12_1.  
2. Uzupelnic definicje metod w pliku modulowym lista7_3.cpp.
3. Wykonac projekt zawierajacy pliki: lab7_3.cpp, punkt7_2.cpp
   ramka7_2.cpp, napis7_2.cpp, nram7_3.cpp, lista7_3.cpp. Program
   wykonywalny  powinien dzialac podobnie jak lab7_3.cpp

 Pytania kontrolne:
 1. Podaj korzysci wynikajace z zastosowania Listy obiektow. Porownaj
    to rozwiaznie z rozwiazaniem LAB12_1.
 2*. Pytanie dla ambitnych
     Podaj inna definicje elementu listy-tablicy, aby uzyskac
     podobne rozwiazanie (podobnie uniwersalne wykluczajac
     jeszcze zastosowanie szablonu).
*/
#include "nram7_2.h"
#include "lista7_3.h"
#include <iostream.h>
#include <conio.h>
void wyswietl(punkt&, char * kom);
void wyswietl(float, char * kom);

void main()
{ clrscr();
  { n_ramka *n_r1, *n_r2;
    ramka* r1,*r2;
    napis* n1,*n2;
    punkt* p1,*p2;
    ab p;
    lista Lista(8);
    n_r1 = new n_ramka(36,10,19,8,"napis w ramce_1",0x3A);
    Lista.wstaw(n_r1);
    n_r2 = new n_ramka(54,8,19,5,"napis w ramce_2",0x1B);
    Lista.wstaw(n_r2);
    r1 = new ramka(50,12,10,8);
    Lista.wstaw(r1);
    r2 = new ramka(60,9,10,5);
    Lista.wstaw(r2);
    n1 = new napis(50,21,"napis1");
    Lista.wstaw(n1);
    n2 = new napis(63,18,"napis2");
    Lista.wstaw(n2);
    p1 = new punkt(12,13);
    Lista.wstaw(p1);
    p2 = new punkt(12,8);
    Lista.wstaw(p2);
 getch();
 clrscr();
 Lista.Dla_kazdego(); //dzieki wirtualnej metodzie wyswietl klasy abstr
 //wywolywanej w metodzie wyswietl Listy;metoda wyswietl jest przede-
 //finiowana w klasach pochodnych wstawionych do Listy
 while (!Lista.pusty())
  {
   p=Lista.usun();
   --(*p);--(*p);             //dzieki polimorfizmowi klasy abstrakcyjnej
   wyswietl(*((punkt*)p),""); //dzieki polimorfizmowi klasy wirtualnej punkt
   wyswietl(((punkt*)p)->odleglosc(*n_r1),"");
  }
 Lista.wstaw(n_r1); Lista.wstaw(n_r2);
 Lista.wstaw(r1);   Lista.wstaw(r2);
 Lista.wstaw(n1);   Lista.wstaw(n2);
 Lista.wstaw(p1);   Lista.wstaw(p2);
 Lista.Dla_kazdego();
 // dzieki polimorfizmowi klasy abstrakcyjnej
 //usuwanie elementow Listy, pochodnych klasy abstr!
 //wywolany destruktor stosu usuwa kazdy ze wstawuonych do Listy
 //obiektow dzieki wirtualnemu destruktorowi klasy abstr i przedefiniowanym
 //destruktorom klas pochodnych wstawionych do Listy
 }
 }
/* uniwersalna funkcja do wyswietalnia pol calej rodziny obiektow:
   punkt, ramka, napis oraz n_ramka dzieki:
 * przekazywaniu przez referencje
 * zastosowaniu polimorfizmu, czyli wywolywaniu metod wirtualnych:
   p_dlugosc, p_wiersz, p_wysokosc, p_atrybuty
 */
void wyswietl(punkt& p, char *kom)
{
 cout << "Atrybuty: " << p.p_atrybuty();
 cout << " Wiersz: " << p.p_wiersz();
 cout << " Dlugosc, Wysokosc: " << p.p_dlugosc() << " "
			 <<p.p_wysokosc() <<" ";
 cout << " Wspolrzedne: " << p.odcieta() << " "<< p.rzedna() <<kom;
 p.rysuj();
 getch();
 clrscr();
}

 void wyswietl(float w,char *napis)
{
 cout <<napis<< w << '\n';
 getch();
}

