/*Dziedziczenie - polimorfizm, kolejka jako struktura dynamiczna
 przechowujaca wskazniki elementow z rodziny abstr.

 Klasy punkt, ramka, napis oraz n_ramka sa pochodnymi klasami klasy
 abstrakcyjnej abstr, posiadajacej czyste metody wirtualne: rysuj,
 przedrostkowe operatory -- i ++ oraz zwykly wirtualny destruktor
 Zostaly wykonane w LAB12_1.

 Zadania do wykonania:
 1.Uzupelnij definicje metod w pliku kol8_4.cpp oraz kol8_4.h
   zawierajace deklaracje i definicje metod klasy kolejka.
   Wykonanie definicji metod wykonac w oparciu definicje
   rekurencyjnego stosu, zdefiniowanego w LAB13\GOTOWE\STOS.
 2.Zastosuj dyrektywy preprocesora zabezpieczajace przed ponowna
   kompilacja plikow naglowkowych. Uzupelnij pozostale makrodefinicje
   w plikach naglowkowych.
 3.Wykonaj projekt zawierajcy:
   punkt7_2.cpp, ramka7_2.cpp, napis7_2.cpp, nram7_2.cpp, kol8_4.cpp,
   lab8_4.cpp i skompiluj. Program powinien dzialac jak lab8_4.exe.

 Pytania kontrolne
 1. Wyjasnij dzialanie metody kolejki Dla_kazdego(void(*)(abstr*)),
    wywolanej jako Kolejka.Dla_kazdego(wyswietl)
 2. Wyjasnij dzialanie wywolanej funkcji wyswietl((punkt*)p) oraz
    wywolanej funkcji wyswietl(p), gdzie abstr* p.
*/
#include "nram7_2.h"
#include "kol8_4.h"
#include <iostream.h>
#include <conio.h>
void wyswietl(punkt*);
void wyswietl(abstr*);
void wyswietl(float, char * kom);

void main()
{ clrscr();
{ n_ramka *n_r1, *n_r2;
  ramka* r1,*r2;
  napis* n1,*n2;
  punkt* p1,*p2;
  abstr* p;
  kolejka Kolejka;
  n_r1 = new n_ramka(36,10,19,8,"napis w ramce_1",0x3A);
  Kolejka.wstaw(n_r1);
  n_r2 = new n_ramka(54,8,19,5,"napis w ramce_2",0x1B);
  Kolejka.wstaw(n_r2);
  r1 = new ramka(50,12,10,8);
  Kolejka.wstaw(r1);
  r2 = new ramka(60,9,10,5);
  Kolejka.wstaw(r2);
  n1 = new napis(50,21,"napis1");
  Kolejka.wstaw(n1);
  n2 = new napis(63,18,"napis2");
  Kolejka.wstaw(n2);
  p1 = new punkt(12,13);
  Kolejka.wstaw(p1);
  p2 = new punkt(12,8);
  Kolejka.wstaw(p2);
  getch();
  clrscr();
  Kolejka.Dla_kazdego(wyswietl); //dzieki polimorfizmowi klasy abstrakcyjnej
  while (!Kolejka.pusty())
	{
	 p=Kolejka.usun();
	 --(*p);                 //dzieki polimorfizmowi klasy abstrakcyjnej
	 p->wyswietl("");        //dzieki polimorfizmowi klasy abstrakcyjnej
	 wyswietl((punkt*)p);    //dzieki polimorfizmowi klasy punkt
	 wyswietl(((punkt*)p)->odleglosc(*n_r1),"");
	}
 Kolejka.wstaw(n_r1); Kolejka.wstaw(n_r2);
 Kolejka.wstaw(r1);   Kolejka.wstaw(r2);
 Kolejka.wstaw(n1);   Kolejka.wstaw(n2);
 Kolejka.wstaw(p1);   Kolejka.wstaw(p2);
 Kolejka.Dla_kazdego(wyswietl);// dzieki polimorfizmowi klasy abstrakcyjnej
 //wywolanie destruktora kolejki - usuwanie elementow kolejki, pochodnych
 //klasy abstr, dzieki jej wirtualnemu destruktorowi, przedefiniowanemu
 //w klasach pochodnych
 }
 }
/* uniwersalna funkcja do wyswietalnia pol calej rodziny obiektow:
   punkt, ramka oraz napis dzieki:
 * przekazywaniu obiektow przez wskaznik
 * zastosowaniu polimorfizmu, czyli wywolywaniu metod wirtualnych:
   p_dlugosc, p_wiersz, p_wysokosc
 */

void wyswietl(punkt* p)
{
 cout << "Atrybuty: " << p->p_wiersz();
 cout << " Wiersz: " << p->p_wiersz();
 cout << " Dlugosc, Wysokosc: " << p->p_dlugosc() << " "
			 <<p->p_wysokosc() <<" ";
 cout << "\n Wspolrzedne: " << p->odcieta() << " "<< p->rzedna();
 p->rysuj();
 getch();
 clrscr();
}

//funkcja do wyswietlenia elementow typu abstr* umieszczonych na stosie
void wyswietl(abstr* p)
{
 --(*p);
 p->wyswietl("");
 getch();
 clrscr();
}

 void wyswietl(float w,char *napis)
 {
  cout <<napis<< w << '\n';
  getch();
 }
