/*1. Dziedziczenie jednobazowe
  2. Konstruktory z lista i bez listy argumentow

 Zrealizowac klase kolo do obslugi kol na plaszczyznie. Klasa kolo
 dziedziczy od klasy punkt. Opis klasy znajduje sie w wykladzie 7
 (Jezyki i metody programowania-C2).
 Wykonaj konstruktory: zwykly i kopiujacy:
 * bez list argumentow: w klasie punkt i w klasie kolo.
 * z zastosowaniem listy w klasie kolo i punkt

Wykonac:
1.1. Dokonac analizy dzialania programu lab511.exe.
1.2. Wykonac definicje metod w plikach modulowych punkt511.cpp oraz
     kolo511.cpp. Wykonac konstruktory bez listy argumentow
1.3. Zastosowac dyrektywy uniemozliwiajace ponowna kompilacje
     plikow naglowkowych. Uzupelnic pozostale makrodefinicje w plikach 
     naglowkowych.
1.4. Wykonac projekt laczacy pliki modulowe punkt511.cpp, kolo511.cpp
     oraz lab5_1.cpp. Otrzymany program po kompilacji i laczeniu powinien 
     dzialac podobnie jak program lab511.exe.

2.1. Dokonac analizy dzialania programu lab512.exe.
2.2. Wykorzystac pliki punkt511.cpp oraz kolo511.cpp stosujac w definicji 
     konstruktorow liste argumentow i zachowaj je jako punkt512.cpp oraz
     kolo512.cpp. 
2.3. Zastosowac pliki naglowkowe punkt5_1.h oraz kolo5_1.h z punktu 1.
2.4. Wykonac projekt laczacy pliki modulowe punkt512.cpp, kolo512.cpp
     oraz lab5_1.cpp. Otrzymany program po kompilacji i laczeniu powinien
     dzialac podobnie jak program lab512.exe.
3.   Porownac dzialanie programow lab511.exe i lab512.exe z programami 
     z lab3_a oraz lab3_b z LAB4_1 i LAB4_2.

Pytania kontrolne:
1. Podaj sposob wywolania wszystkich konstruktorow i destruktorow
   w programie lab511.exe oraz lab512.exe. Porownaj go ze sposobem
   wywolania konstruktorow i destruktorow w przypadku, gdy klasa punkt jest
   zagniezdzona w klasie kolo (LAB4_1 i LAB4_2).
2. Wskaz w programie lab5_1.cpp miejsca, gdzie obiekty typu kolo wywoluja
   metody dziedziczone od klasy punkt.
*/

#include <iostream.h>
#include "kolo5_1.h"
#include <conio.h>

void wyswietl(kolo&);
void wyswietl(punkt&);
void wyswietl(float,char*);
void wyswietl(int,int);
main()
{ clrscr();
 { wyswietl(kolo::liczba_kol(),kolo::info());
   wyswietl(punkt::liczba_punktow(),punkt::info());
   kolo p1(2, 2, 3), p2(1, 5, 6);
   wyswietl(p1); wyswietl(p2);
   wyswietl(kolo::liczba_kol(),kolo::info());
   wyswietl(punkt::liczba_punktow(),punkt::info());
   wyswietl(p1.odleglosc(p2),"Odleglosc: ");
   wyswietl(p1.pole(),"Pole kola: ");
   kolo p3=p1;
   wyswietl(p3);
 }
   wyswietl(kolo::liczba_kol(),kolo::info());
   wyswietl(punkt::liczba_punktow(),punkt::info());
   return 0;
}

void wyswietl(kolo& p)
{
 punkt pom;
 pom=p;  //Mozna przypisywac nastepce do poprzednika lub obiekty
	 //z tych samych klas.Takie przypisanie ma charakter ograniczajacy.
         //Ograniczenie obiektu p typu kolo do obiektu pom typu punkt
         //w celu unikniecia rekurencyjnego wywolania funkcji wyswietl.
         //Jest to skutek uboczny przeciazania funkcji wyswietl dla klasy
         //bazowej punkt i pochodnej kolo.
 wyswietl(pom);
 cout <<"Promien: " << p.p_promien() << '\n';
 getch();
}               

void wyswietl(punkt& p)
{
 cout <<"Wspolrzedne: " << p.odcieta() << " "<< p.rzedna() << " ";
 getch();
}

void wyswietl(float w, char* l)
{
 cout <<l << w << '\n';
 getch();
}

void wyswietl(int w,int nr)
{
 cout <<"Liczba obiektow: " << w << " o numerze "<< nr <<'\n';
 getch();
}