/*1. Dziedziczenie i pokrywanie metod (operatorow)
  2. Operatory przyrostkowe i przedrostkowe -- oraz ++

 Zrealizowac klase kolo do obslugi kol na plaszczyznie. Klasy kolo
 i punkt powinny zawierac: 
 1. konstruktory: zwykly i kopiujacy za pomoca listy argumentow
 2. operatory operator++ oraz operator-- przedrostkowe i przyrostkowe 
    w klasie punkt i pokryte w klasie kolo.
 Metody te powinny zwiekszac lub zmniejszac pola x i y w klasie punkt
 i dodatkowo pole promien w klasie kolo. W definicjach operatorow
 w klasie kolo wykorzystaj dziedziczone operatory -- oraz ++
 od klasy punkt.

Wykonac
1. Zdefiniowac metody w plikach modulowych punkt5_3.cpp oraz 
   kolo5_3.cpp.
2. Zastosowac dyrektywy uniemozliwiajace ponowna kompilacje
   plikow naglowkowych.
   Uzupelnic pozostale makrodefinicje w plikach naglowkowych.
3. Wykonac projekt laczacy pliki modulowe punkt5_3.cpp, kolo5_3.cpp
   oraz plik programu lab5_3.cpp.
4. Porownac dzialanie programu lab5_3.exe z uzyskanym programem
   po kompilacji i laczeniu. Oba programy powinny dzialac podobnie.

Pytania kontrolne:
1. Scharakteryzuj dzialanie przeciazonych operatorow ++ i -- na podstawie
   programu lab5_3.cpp.
2. Czy operatory przeciazone ++ i -- moga byc metodami typu const?
*/

#include <iostream.h>
#include "kolo5_3.h"
#include <conio.h>
void wyswietl(kolo&, char *napis);
void wyswietl(punkt&, char *napis);
void wyswietl(float);

main()
{ clrscr();
 { kolo kolo1(2, 2, 3), kolo2(1, 5, 6);
   punkt punkt1 (2, 3), punkt2(2, 8);
   wyswietl(kolo1,"kolo1: "); 	       wyswietl(kolo2,"kolo2: ");
   wyswietl(punkt1,"punkt1: ");        wyswietl(punkt2,"punkt2: ");
   wyswietl(++kolo1,"++kolo1: ");      wyswietl(++kolo2,"++kolo2: ");
   wyswietl(++punkt1,"++punkt1: ");    wyswietl(++punkt2,"++punkt2: ");
   wyswietl(--kolo1,"--kolo1: ");      wyswietl(--kolo2,"--kolo2: ");
   wyswietl(--punkt1,"--punkt1: ");    wyswietl(--punkt2,"--punkt2: ");
   wyswietl(kolo1--,"kolo1--: ");      wyswietl(kolo2--,"kolo2--: ");
   wyswietl(punkt1--,"punkt1--: ");    wyswietl(punkt2--,"punkt2--: ");
   wyswietl(kolo1++,"kolo1++: ");      wyswietl(kolo2++,"kolo2++: ");
   wyswietl(punkt1++,"punkt1++: ");    wyswietl(punkt2++,"punkt2++: ");
   wyswietl(kolo1.odleglosc(kolo2));
   float a = (kolo1--).odleglosc((kolo2++));
   wyswietl(a);
   wyswietl(kolo1.odleglosc(kolo2));
 }
  return 0;
}

void wyswietl(kolo& p, char *napis)
{
 punkt pom;
 pom=p;
 cout << napis <<" Promien: " << p.p_promien();
 wyswietl(pom,"");
 getch();
}

void wyswietl(punkt& p, char *napis)
{
 cout << napis <<" Wspolrzedne: " << p.odcieta() << " "<< p.rzedna() <<'\n';
 getch();
}

void wyswietl(float w)
{
 cout <<"Odleglosc: " << w << '\n';
 getch();
}
