/* Glowne zagadnienie
 * Dziedziczenie - polimorfizm

Opis klas:
    Klasa punkt zawiera metody wirtualne zapowiadajace konkretne metody
 dostepu do pol dlugosc i wysokosc w klasie ramka oraz do pol
 dlugosc i wiersz w klasie napis, metode rysuj oraz przeciazone
 operatory-- i ++ do powiekszania i zmniejszania o 1 wartosci pol,
 oraz pozostale skladowe:
 pola x, y, konstruktory zwykly i kopiujacy, destruktor,
 metody dostepu do pol, metode odleglosc do wyznaczania odleglosci
 miedzy dwoma punktami-*this oraz przekazanym przez wartosc do metody
 oraz zwykla metode wyswietl wywolujaca metody wirtualme.
    Klasy napis i ramka dziedzicza pola i metody od klasy punkt.
 Klasa napis posiada: pola wiersz  w postaci tablicy dynamicznej
 znakow i dlugosc do przechowywania wielkosci pamieci przezmaczonej
 na wiersz oraz: konstruktory zwykly i kopiujacy, destruktor,
 przeciazony operator= oraz metody wirtualne przedefiniowane: dostepu
 do pol wiersz oraz dlugosc, metode rysuj do wyswietlania napisu
 we wskazanym punkcie ekranu, operatory ++ oraz -- (zwiekszajace lub
 zmniejszajace o 1 bajt obszar w pamieci przeznaczony do przechowywania
 napisu oraz zmieniajace wspolrzedne napisu x,y operatorami-- i ++
 klasy punkt).Klasa ramka dziedziczy metode wirtualna "dostepu"
 p_wysokosc od klasy punkt, ktorej nie wykorzystuje.
    Klasa ramka posiada pola dlugosc i wysokosc rysowanej ramki,
 konstruktory zwykly i kopiujacy, destruktor, przedefiniowane metody
 wirtualne dostepu do pol dlugosc oraz wysokosc, operatory ++ oraz --
 (zwiekszajace lub zmniejszajace o 1 wartosc pol wysokosc i dlugosc
 oraz wartosci wspolrzednych x,y za pomoca dziedziczonych operatorow++
 i -- od klasy punkt), metode rysuj do rysowania ramki o rozmiarach
 dlugosc i wysokosc w punkcie (x,y). Klasa ramka dziedziczy metode
 wirtualna "dostepu" p_wiersz od klasy punkt, ktorej nie
 wykorzystuje.

Zadania do wykonania:
 1. Wykonaj konstruktory: zwykly i kopiujacy za pomoca listy
    argumentow w klasach punkt, ramka i napis
 2. Wykonaj operatory operator++ oraz operator-- przedrostkowe
    w klasie punkt, ramka oraz napis.
    Metody te powinny zwiekszac lub zmniejszac pola x i y w klasie
    punkt; rozmiar tablicy znakow oraz polozenie napisu na ekranie
    w klasie napis; wspolrzedne x,y polozenia ramki oraz wymiary
    dlugosc i wysokosc w klasie ramka.
    W definicjach operatorow w klasach ramka i napis wykorzystaj
    dziedziczenie operatorow -- oraz ++ od klasy punkt.
 3. Wykonaj pozostale metody na podstawie zadania z LAB10_2.

 Uwagi dotyczace wykonania:
 1. Zabezpiecz pliki naglowkowe punkt7_1.h, ramka7_1.h, napis7_1.h
    przed wielokrotna deklaracja.
    Uzupelnij pozostale makrodefinicje w plikach naglowkowych.
 2. Wykonaj definicje metod klas punkt, ramka i napis odpowiednio
    w plikach modulowych: punkt7_1.cpp,	ramka7_1.cpp, napis7_1.cpp.
    Mozna skorzystac z definicji podanych w plikach z LAB10_2.
 3. Wykonaj projekt zawierajacy: plik lab7_1.cpp, ramka7_1.cpp,
    napis7_1.cpp. Uzyskany program wykonywalny powinien dzialac
    podobnie jak lab7_1.exe.

Pytania kontrolne:
 1. Wskaz w programie miejsca, wstawiajac w komentarzu dowolne oznaczenia,
    gdzie wykorzystano polimorfizm.
 2. Zakladamy, ze funkcje wyswietl w tym programie sa rownowazne,
    podane jedynie dla zaprezentowania polimorfizmu wspomaganego
    przekazywaniem obiektow przez referencje i wskaznik, stad nalezy
    przyjac, ze mamy jedna funkcje wyswietl w programie. Podaj,
    jakie funkcje musza byc zdefiniowane w programie, aby wyswietlic
    zawartosc wszystkich obiektow z rodziny punkt, gdyby nie zastosowano
    polimorfizmu. Podaj ich liczbe.
 3. Ile nalezaloby zdefiniowac metod wyswietl, aby mozna bylo wyswietlic
    zawartosc wszystkich obiektow w programie, gdyby nie zastosowano po-
    limorfizmu?*/


#include "ramka7_1.h"
#include "napis7_1.h"
#include <iostream.h>
#include <conio.h>
void wyswietl(punkt&, char * kom);
void wyswietl(punkt*, char * kom);
void wyswietl(float, char * kom);

void main()
{ clrscr();
 { ramka r1(50,12,10,8),     r2(60,9,10,5);
   napis n1(50,21,"napis1"), n2(63,18,"napis2");
   punkt p1 (2,5),	     p2(2,8);
   getch();
   clrscr();
// Pierwszy sposob -
// jedna funkcja wywolujaca wirtualne metody, dynamicznie
// dolaczane przez kompilator zaleznie od podstawionego obiektu
// przez referencje
   wyswietl(r1,"  r1\n"); 	wyswietl(r2,"  r2\n");
   wyswietl(n1,"  n1\n"); 	wyswietl(n2,"  n2\n");
   wyswietl(p1,"  p1\n"); 	wyswietl(p2,"  p2\n");
// Drugi sposob -
// jedna funkcja wywolujaca wirtualne metody, dynamicznie
// dolaczane przez kompilator zaleznie od podstawionego obiektu
// przez wskaznik
//oraz:
 //przedefiniowane przeciazone metody-operatory++ i --
 //zdefiniowane za pomoca operatorow ++ i -- dziedziczonych
 //od klas punkt, ramka i napis wywolane w funkcji wyswietl(&...) (--)
   wyswietl(&r1,"  --r1\n");
   wyswietl(&n1,"  --n1\n");
   wyswietl(&p1,"  --p1\n");
// Trzeci sposob -
// jedna metoda zwykla w klasie praprzodka (punkt) wywolujaca metody
// wirtualne, dynamicznie dolaczane przez kompilator zaleznie
// od wywolujacego obiektu
//oraz:
 //przedefiniowane przeciazone metody-operatory++ i --
 //zdefiniowane za pomoca operatorow ++ i -- dziedziczonych
 //od klas punkt, ramka i napis wywolane w metodzie wyswietl (++)
   r2.wyswietl("  ++r2\n");
   n2.wyswietl("  ++n2\n");
   p2.wyswietl("  ++p2\n");
//wywolanie metody dziedziczonej odleglosc od klasy punkt
   wyswietl(r1.odleglosc(r2),"Odleglosc miedzy ramkami: ");
   wyswietl(n1.odleglosc(n2),"Odleglosc miedzy napisami: ");
   wyswietl(p1.odleglosc(p2),"Odleglosc miedzy punktami: ");
   n2.rzedna()+=2;  //zmiana wspolrzednej y napisu metoda klasy punkt
   n1=n2;           //wywolanie przeciazonego operatora = z klasy napis
   wyswietl(n1.odleglosc(n2),"Odleglosc miedzy napisami: ");
   clrscr();
   wyswietl(n1,"  n1\n");
   wyswietl(n2,"  n2\n");
   getch();
 }
}
/* uniwersalna funkcja do wyswietlania pol calej rodziny obiektow:
   punkt, ramka oraz napis dzieki:
 * przekazywaniu przez referencje
 * zastosowaniu polimorfizmu, czyli wywolywaniu metod wirtualnych:
   p_dlugosc, p_wiersz, p_wysokosc,rysuj
 */

void wyswietl(punkt& p, char *kom)
{
 cout << "Wiersz: " << p.p_wiersz();
 cout << " Dlugosc, Wysokosc: " << p.p_dlugosc() << ", "
			 <<p.p_wysokosc() <<" ";
 cout << " Wspolrzedne: " << p.odcieta() << " "<< p.rzedna() <<kom;
 p.rysuj();
 getch();
 clrscr();
}

/* uniwersalna funkcja do wyswietlania pol calej rodziny obiektow:
   punkt, ramka oraz napis dzieki:
 * przekazywaniu przez wskaznik
 * zastosowaniu polimorfizmu, czyli wywolywaniu metod wirtualnych:
   p_dlugosc, p_wiersz, p_wysokosc, rysuj i operatora wirtualnego --
*/

void wyswietl(punkt* p, char *kom)
{
 --(*p);
 cout << "Wiersz: " << (*p).p_wiersz();
 cout << " Dlugosc, Wysokosc: " << p->p_dlugosc() << ", "
			 <<p->p_wysokosc() <<" ";
 cout << " Wspolrzedne: " << p->odcieta() << " "<< p->rzedna() <<kom;
 p->rysuj();
 getch();
 clrscr();
}

void wyswietl(float w,char *napis)
{
 cout <<napis<< w << '\n';
 getch();
}

