/*Dziedziczenie - polimorfizm, stos jako szablon rekurencyjnej 
  struktury dynamicznej przechowujacej wskazniki parametru T szablonu.
  Szablon stosu zastosowano dla stosu ST elementow zawierajacych wskazniki
  typu int i oraz stosu elementow Stos zawierajacych wskazniki
  elementow z rodziny abstr.
  Klasy punkt, ramka, napis oraz n_ramka sa pochodnymi klasami klasy
  abstrakcyjnej abstr, posiadajacej czyste metody wirtualne: rysuj,
  przedrostkowe operatory -- i ++ oraz zwykly wirtualny destruktor
  Zostaly wykonane w lab7_2.
  Program zostal opisany w pliku Wyklad13.doc.
*/
#include "nram7_2.h"
#include "tstos8_1.h"
#include <iostream.h>
#include <conio.h>
void wyswietl(punkt*);
void wyswietl(abstr*);
void wyswietl(int*);
void wyswietl(float, char * kom);

void main()
{ clrscr();
  { int * l;
    stos<int> ST;
    l=new int; *l=1;  ST.wstaw(l);
    l=new int; *l=2;  ST.wstaw(l);
    l=new int; *l=3;  ST.wstaw(l);
    l=new int; *l=4;  ST.wstaw(l);
//uniwersalna metoda stosu o elementach typu int (parametr int)
//posiadajacego funkcje niezalezna o naglowku void(*)(int*)
//np. wyswietl(int*)
		ST.Dla_kazdego(wyswietl);
		n_ramka *n_r1, *n_r2;
		ramka* r1,*r2;
		napis* n1,*n2;
		punkt* p1,*p2;
//stos wskaznikow elementow z rodziny abstr
		stos <abstr> Stos;
		abstr* p;
		n_r1 = new n_ramka(36,10,19,8,"napis w ramce_1",0x3A);
		Stos.wstaw(n_r1);
		n_r2 = new n_ramka(54,8,19,5,"napis w ramce_2",0x1B);
		Stos.wstaw(n_r2);
		r1 = new ramka(50,12,10,8);
		Stos.wstaw(r1);
		r2 = new ramka(60,9,10,5);
		Stos.wstaw(r2);
		n1 = new napis(50,21,"napis1");
		Stos.wstaw(n1);
		n2 = new napis(63,18,"napis2");
		Stos.wstaw(n2);
		p1 = new punkt(12,13);
		Stos.wstaw(p1);
		p2 = new punkt(12,8);
		Stos.wstaw(p2);
		getch();
		clrscr();
 //uniwersalna metoda stosu stosu o elementach rodziny abstr (parametr abstr)
 // posiadajacego funkcje niezalezna o naglowku
 //void(*)(abstr*) np. wyswietl(abstr*)
 Stos.Dla_kazdego(wyswietl);
 while (!Stos.pusty())
	{
	 p=Stos.usun();
	 --(*p);              //dzieki polimorfizmowi klasy abstrakcyjnej
	 p->wyswietl("");     //dzieki polimorfizmowi klasy abstrakcyjnej
	 wyswietl(p);         //dzieki polimorfizmowi klasy abstrakcyjnej
	 wyswietl(((punkt*)p)->odleglosc(*n_r1),"");
	}
//stos wskaznikow elementow z rodziny punkt
	stos <punkt> Stos_;
	punkt* p_;
	Stos_.wstaw(n_r1);
	Stos_.wstaw(n_r2);
	Stos_.wstaw(r1);
	Stos_.wstaw(r2);
	Stos_.wstaw(n1);
	Stos_.wstaw(n2);
	Stos_.wstaw(p1);
	Stos_.wstaw(p2);
	getch();
	clrscr();
 //uniwersalna metoda stosu o elementach rodziny punkt (parametr punkt)
 // posiadajacego funkcje niezalezna o naglowku
 //void(*)(punkt*) np. wyswietl(punkt*)
 Stos_.Dla_kazdego(wyswietl);
 while (!Stos_.pusty())
	{
	 p_=Stos_.usun();
	 --(*p_);              //dzieki polimorfizmowi klasy wirtualnej punkt
	 p_->wyswietl("");     //dzieki polimorfizmowi klasy wirtualnej punkt
	 wyswietl(p_);         //dzieki polimorfizmowi klasy wirtualnej punkt
	 wyswietl(p_->odleglosc(*n_r1),"");
	 delete p_; //wywolanie wirtualnych destruktorow z klas aktualnych
	 //obiektow z rodziny punkt
	}
 //usuniecie stosu elementow typu int dzieki destruktorowi klasy stos
 //oraz stosow Stos otaz Stos_. Elementy tych stosow zostaly usuniete
 //w drugiej petli while.
 } }
/* uniwersalna funkcja do wyswietalnia pol calej rodziny obiektow:
   punkt, ramka, napis oraz n_ramka dzieki:
 * przekazywaniu obiektow przez wskaznik
 * zastosowaniu polimorfizmu, czyli wywolywaniu metod wirtualnych:
   p_dlugosc, p_wiersz, p_wysokosc
 */
void wyswietl(punkt* p)
{
 cout << "Atrybuty: " << p->p_wiersz();
 cout << " Wiersz: " << p->p_wiersz();
 cout << " Dlugosc, Wysokosc: " << p->p_dlugosc() << " "
			 <<p->p_wysokosc() <<" ";
 cout << "\n Wspolrzedne: " << p->odcieta() << " "<< p->rzedna();
 p->rysuj();
 getch();
 clrscr();
}

//funkcja do wyswietlania stosu elementow typu abstr*
void wyswietl(abstr* p)
{
 --(*p);
 p->wyswietl("");
 getch();
 clrscr();
}
//funkcja do wyswietlania stosu elementow int*
 void wyswietl(int* w)
{
 cout << *w << "\n";
 getch();
}

 void wyswietl(float w,char *napis)
{
 cout <<napis<< w << '\n';
 getch();
}
