/*Dziedziczenie - polimorfizm, kolejka jako szablon struktury dynamicznej
  przechowujacej wskazniki parametru T szablonu.
  Szablon kolejki zastosowano dla kolejki KL elementow zawierajacych wskazniki
  typu int oraz kolejki elementow Kolejka zawierajacych wskazniki
  elementow z rodziny abstr.
  Klasy punkt, ramka, napis oraz n_ramka sa pochodnymi klasami klasy
  abstrakcyjnej abstr, posiadajacej czyste metody wirtualne: rysuj,
  przedrostkowe operatory -- i ++ oraz zwykly wirtualny destruktor
  Zostaly wykonane w LAB12_1;

 Zadania do wykonania:
 1.Uzupelnij definicje metod w pliku tkol8_4.h
   zawierajace deklaracje i definicje metod szblonu klasy kolejka.
   Wykonanie definicji metod wykonac w oparciu definicje
   szablonu rekurencyjnego stosu, zdefiniowanego w LAB13\GOTOWE\SZABSTOS
 2.Zastosuj dyrektywy preprocesora zabezpieczajace przed ponowna
   kompilacja pliki naglowkowe. Uzupelnij pozostale dyrektywy preprocesora
   w plikach naglowkowych.
 3.Wykonaj projekt zawierajcy:
   punkt7_2.cpp, ramka7_2.cpp, napis7_2.cpp, nram7_2.cpp,lab8_5.cpp
   i skompiluj. Program powini dzialac jak lab8_5.exe.

 Pytania kontrolne
 1. Wyjasnij dzialanie metody kolejki:
    Dla_kazdego(void(*)(abstr*)) dla kolejka<abstr> Kolejka
    Dla_kazdego(void(*)(punkt*)) dla kolejka<punkt> Kolejka_
    Dla_kazdego(void(*)(int*)) dla kolejka<int>KL
 2. Wyjasnij dzialanie wywolanej funkcji wyswietl(p) oraz
    wywolanego operatora --(*p), gdzie abstr* p
    oraz wyswietl(p_) i --(*p_), gdzie punkt* p_
    w petlach while
*/
#include "nram7_2.h"
#include "tkol8_4.h"
#include <iostream.h>
#include <conio.h>
void wyswietl(punkt*);
void wyswietl(abstr*);
void wyswietl(int*);
void wyswietl(float, char * kom);

void main()
{ clrscr();
 { //kolejka elementow typu int*
	 kolejka<int> KL;
	 int * l;
	 l=new int; *l=1;  KL.wstaw(l);
	 l=new int; *l=2;  KL.wstaw(l);
	 l=new int; *l=3;  KL.wstaw(l);
	 l=new int; *l=4;  KL.wstaw(l);
	 KL.Dla_kazdego(wyswietl);//uniwersalna metoda kolejki dla kolejki
	//o elementach typu int i parametrem int; posiadajacego funkcje
	//niezalezna o naglowku void(*)(int*) np wyswietl(int*)
	 n_ramka *n_r1, *n_r2;
	 ramka* r1,*r2;
	 napis* n1,*n2;
	 punkt* p1,*p2;
 //kolejka elementow abstr*
	 kolejka <abstr> Kolejka;
	 abstr* p;
	 n_r1 = new n_ramka(36,10,19,8,"napis w ramce_1",0x3A);
	 Kolejka.wstaw(n_r1);
	 n_r2 = new n_ramka(54,10,19,5,"napis w ramce_2",0x1B);
	 Kolejka.wstaw(n_r2);
	 r1 = new ramka(50,12,10,8);
	 Kolejka.wstaw(r1);
	 r2 = new ramka(60,9,10,5);
	 Kolejka.wstaw(r2);
	 n1 = new napis(50,21,"napis1");
	 Kolejka.wstaw(n1);
	 n2 = new napis(63,18,"napis2");
	 Kolejka.wstaw(n2);
	 p1 = new punkt(12,13);
	 Kolejka.wstaw(p1);
	 p2 = new punkt(12,8);
	 Kolejka.wstaw(p2);
	 getch();
	 clrscr();
	 Kolejka.Dla_kazdego(wyswietl); //uniwersalna metoda kolejki dla kolejki
 //o elementach rodziny abstr i parametrem abstr; posiadajacego funkcje
 //niezalezna o naglowku void(*)(abstr*) np wyswietl(abstr*)
 while (!Kolejka.pusty())
	{
	 p=Kolejka.usun();
	 --(*p);
	 p->wyswietl("");
	 wyswietl(p);
	 wyswietl(((punkt*)p)->odleglosc(*n_r1),"");
	}
	//kolejka elementow punkt*
	kolejka <punkt> Kolejka_;
	punkt* p_;
	Kolejka_.wstaw(n_r1);
	Kolejka_.wstaw(n_r2);
	Kolejka_.wstaw(r1);
	Kolejka_.wstaw(r2);
	Kolejka_.wstaw(n1);
	Kolejka_.wstaw(n2);
	Kolejka_.wstaw(p1);
	Kolejka_.wstaw(p2);
 getch();
 clrscr();
 Kolejka_.Dla_kazdego(wyswietl); //uniwersalna metoda kolejki dla kolejki
 //o elementach rodziny abstr i parametrem abstr; posiadajacego funkcje
 //niezalezna o naglowku void(*)(abstr*) np wyswietl(abstr*)
 while (!Kolejka_.pusty())
	{
	 p_=Kolejka_.usun();
	 --(*p_);            //dzieki polimorfizmowi klasy wirtualnej punkt
	 p_->wyswietl("");   //dzieki polimorfizmowi klasy wirtualnej punkt
	 wyswietl(p_);       //dzieki polimorfizmowi klasy wirtualnej punkt
	 wyswietl(p_->odleglosc(*n_r1),"");
	 delete p_; //wywolanie wirtualnych destruktorow z klasy aktualnego
	 //obiektu z rodziny punkt
	}
 //usuniecie kolejki elementow typu int dzieki destruktorowi klasy kolejka
 //oraz kolejek Kolejka oraz Kolejka_, ktorych elementy zostaly usuniete
 //w petlach while
 }
 }

void wyswietl(punkt* p)
{
 cout << "Atrybuty: " << p->p_wiersz();
 cout << " Wiersz: " << p->p_wiersz();
 cout << " Dlugosc, Wysokosc: " << p->p_dlugosc() << " "
			 <<p->p_wysokosc() <<" ";
 cout << " \nWspolrzedne: " << p->odcieta() << " "<< p->rzedna();
 p->rysuj();
 getch();
 clrscr();
}

//funkcja do wyswietlania elementow typu abstr* umieszczonych na stosie
void wyswietl(abstr* p)
{
 --(*p);
 p->wyswietl("");
 getch();
 clrscr();
}

//funkcja do wyswietlanie elementow int* umieszczonych na stosie
 void wyswietl(int* w)
{
 cout << *w << '\n';
 getch();
}

 void wyswietl(float w,char *napis)
{
 cout <<napis<< w << '\n';
 getch();
}

